import pytest
import pyord


U128_MAX = 2**128 - 1

@pytest.mark.parametrize(
    'n, s',
    [
        (0, "A"),
        (1, "B"),
        (2, "C"),
        (3, "D"),
        (4, "E"),
        (5, "F"),
        (6, "G"),
        (7, "H"),
        (8, "I"),
        (9, "J"),
        (10, "K"),
        (11, "L"),
        (12, "M"),
        (13, "N"),
        (14, "O"),
        (15, "P"),
        (16, "Q"),
        (17, "R"),
        (18, "S"),
        (19, "T"),
        (20, "U"),
        (21, "V"),
        (22, "W"),
        (23, "X"),
        (24, "Y"),
        (25, "Z"),
        (26, "AA"),
        (27, "AB"),
        (51, "AZ"),
        (52, "BA"),
        (U128_MAX - 2, "BCGDENLQRQWDSLRUGSNLBTMFIJAT"),
        (U128_MAX - 1, "BCGDENLQRQWDSLRUGSNLBTMFIJAU"),
        (U128_MAX, "BCGDENLQRQWDSLRUGSNLBTMFIJAV"),
    ]
)
def test_round_trip(n: int, s: str):
    a = pyord.Rune(n)
    assert a.name == s
    assert a.n == n
    b = pyord.Rune.from_str(s)
    assert b.name == s
    assert b.n == n
    if n != U128_MAX:
        assert a != pyord.Rune(n + 1)
    if n != 0:
        assert a != pyord.Rune(n - 1)

